﻿using UnityEngine;
using System.Collections;

public class EnemyAI : MonoBehaviour {

    public DecisionTree root;
    private Transform target;
    private Rigidbody2D Enemy;
    private Animator myAnimator;
    private bool LookRight = false;
    public bool set;
    private float speed = 1;


    void Start() {

        root = new DecisionTree();
        //  Debug.Log("start");
        target = GameObject.Find("Player").transform; //look at the player
        myAnimator = GetComponent<Animator>(); //required for animation *******
        Enemy = GetComponent<Rigidbody2D>();
        BuildDecisionTree();
    }

    void Update() {
        root.search();

    }

    public bool a_inAttackRange() {
        if (Vector3.Distance(transform.position, target.position) < 1.5f) {
            myAnimator.SetBool("speed", false);
            return false;
        }
        else {
            myAnimator.SetBool("block", false);
            myAnimator.SetBool("attack", false);
            // Debug.Log("In Zone- not");
			return true;
        }
    }

    public bool a_isPlayerAttacking() {
        if (Input.GetKeyDown(KeyCode.Space) && Vector3.Distance(transform.position, target.position) < 5f) {
            return false;
        }
        return true;
    }

    /*
    public bool hpLevel() {
        //   Debug.Log("hp");
        if (EnemyDamage.health <= 2) {
            return false;
        }
        else {
            return true;
        }
    }
    */
	// DECISIONS
    public void d_attack() {
        Debug.Log("attacking");
        //  myAnimator.SetBool("speed", false);
        myAnimator.SetBool("attack", true);
        Enemy.velocity = Vector2.zero;
    }


    public void d_run() {
		Debug.Log("run");
        //  float option = Random.Range(0, 2);
        // if (option == 1) {
        myAnimator.SetBool("block", true);
        Enemy.velocity = Vector2.zero;
        // }

        //if (option == 2) {
        //    Enemy.AddForce(new Vector2(0, 500));
        // }

    }

    public void d_moveToPlayer() {
        Debug.Log("moving");
        //rotate to look at the player
        //transform.LookAt(target.position);
        myAnimator.SetBool("speed", true);
        transform.position = Vector2.MoveTowards(transform.position, target.position, speed * Time.deltaTime);

        if (target.transform.position.x <= transform.position.x) //players spot in world space as opposed to enemy "self" spot 
        {
            transform.rotation = new Quaternion(0, 180, 0, 0); // flips enemy around to face the player on x axis only
        }
        else if (target.transform.position.x >= transform.position.x) //players spot in world space as opposed to enemy "self" spot
        {
            transform.rotation = new Quaternion(0, 0, 0, 0); // flips enemy around to face the player on x axis only }
        }



    }

    public void BuildDecisionTree() {

        //Actions
        DecisionTree Run = new DecisionTree();
        Run.setAction(d_run);

        DecisionTree MoveToPlayer = new DecisionTree();
        MoveToPlayer.setAction(d_moveToPlayer);

        DecisionTree Attack = new DecisionTree();
        Attack.setAction(d_attack);

		// Decisions
        DecisionTree GettingAttacked = new DecisionTree();
        GettingAttacked.setDecision(a_isPlayerAttacking);
        GettingAttacked.setLeft(Run);
        GettingAttacked.setRight(Attack);

        root.setDecision(a_inAttackRange);
        root.setLeft(GettingAttacked);
        root.setRight(MoveToPlayer);

		/*
        DecisionTree HpLevel = new DecisionTree();
        HpLevel.setDecision(hpLevel);
        HpLevel.setLeft(Attack);
        HpLevel.setRight(Retreat);
        */
    }


}
